﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ConsoleApplication2
{
    class Complexo3
    {
        /**
         * Gera casos de teste para o método exibeNumeroComplexo
         */
        public static void teste()
        {            
            for (int i = -1; i <= 1; i++)
            {
                for (int j = -1; j <= 1; j++)
                {
                    Console.WriteLine("[{0},{1}]\t",i,j);
                    exibeNumeroComplexo(i, j);
                }
                Console.WriteLine();
            }
        }

        /**
         * Método:
         *   leNumeroComplexo
         *   
         *   Lê dois números double sendo que o primeiro
         *   representa a parte real do número e o segundo
         *   representa a parte imaginária do número
         *   
         * Parâmetros:
         *   out double a: parte real do número
         *   out double b: parte imaginária do número
         * 
         * Retorno:
         *   void
         *
         */
        static void leNumeroComplexo(out double a, out double b)
        {
            Console.Write("Entre com a parte real (a): ");
            a = double.Parse(Console.ReadLine());
            Console.Write("Entre com a parte imaginaria (b): ");
            b = double.Parse(Console.ReadLine());
        }
              
        /**
           * exibeNumeroComplexo
           * 
           * Parâmetros:
           *   double i: parte real do nº complexo z=a+bi
           *   double j: parte imaginária do nº complexo z=a+bi
           *   
           * Retorno:
           *   void
           *   
           */
        static void exibeNumeroComplexo(double a, double b)
        {
            
            if ((a == 0) && (b == 0))
            {
                // parte real e imaginária é 0
                Console.WriteLine(0);
            }
            else
            {
                //
                if ((a != 0) && (b != 0))
                {
                    // há um número complexo diferente de 0

                    // não importa o valor da parte real
                    if (b > 0)
                    {
                        // parte imaginária maior que 0
                        Console.WriteLine("{0}+{1}i", a, b);
                    }
                    else
                    {
                        // parte imaginário menor que 0
                        Console.WriteLine("{0}{1}i", a, b);
                    }
                }
                else
                {
                    // i ou j é igual a zero
                    if (a == 0)
                    {
                        // parte real igual a zero
                        // exibe parte imaginária
                        Console.WriteLine("{0}i", b);
                    }
                    if (b == 0)
                    {
                        // parte imaginária igual a zero
                        // exibe parte real
                        Console.WriteLine("{0}", a);
                    }                    
                }
            }
            

        }

        static void Main(string[] args)
        {
            // numeros complexos
            // z=a+bi
            // a soma de dois numeros complexos é dada pela soma das partes reais
            // e das partes imaginária
            // ex: z1=a+bi e z2=c+di 
            //     A soma de z1 + z2 = a+bi + c+di = (a+c)+(b+d)i
            // escreva um método que dados dois números complexos (z1 e z2), retorne a soma dos
            // dois números.
            // vocês deverão necessariamente criar um método que receba 4 números
            // double: a, b, c e d e retornar o valor da soma nas variáveis real 
            // e imaginario

            double a;
            double b;

            //teste();

            leNumeroComplexo(out a, out b);
            exibeNumeroComplexo(a, b);
            

        }
    }
}
